
#
# Volume
# ALSA volume control (code uses amixer command for volume adjustments)
#
# plugin name:
#       volume
#
# available options:
#       none
#
# available commands:
#       +       - increase volume
#       -       - decrease volume
#       m       - mute
#

#
# Copyright 2010 Igor Brkic <igor@hyperglitch.com>
#

class Volume

    def initialize io
        @io=io
    end

    def setup options
    end

    def volume ud, v='5'
        conf={
            'muted'      => 'red3',
        }

        if ['+', '-', 'm'].member? ud then

            set=case ud
                when '+','-': `amixer set Master #{v}dB#{ud}`
                when 'm': `amixer set Master toggle`
                end

            set=set.split("\n")[-1].split
            perc=set[-3].scan(/\d+/)[0].to_i
            mute=(set[-1].scan(/\w+/)[0]=='on')?false:true

            out=@io.bar(perc, 'volume', ['vol-min.xbm', 'vol-mid.xbm', 'vol-max.xbm'])

            @io.output out+"^fg(#{(mute)?conf['muted']:conf['unmuted']})[mute] "
        else
            @io.log '[Volume] wrong argument (volume accepts +, - or m)'
            return
        end
    end

    def run action=[]
        if action.empty? then
            action[0]=@io.input ['+', '-', 'mute'], "[Volume]"
        end
        volume action[0]
    end
end
